git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Bert Wesarg <bert.wesarg@googlemail.com>
To: Uwe Kleine-Koenig <u.kleine-koenig@pengutronix.de>
To: Uwe Kleine-Koenig <u.kleine-koenig@pengutronix.de>
Cc: Bert Wesarg <bert.wesarg@googlemail.com>,
	git@vger.kernel.org, Peter Simons <simons@cryp.to>,
	pasky@suse.cz, Per Cederqvist <ceder@lysator.liu.se>,
	Olaf Dabrunz <odabrunz@gmx.net>,
	Thomas Moschny <thomas.moschny@gmx.de>,
	martin f krafft <madduck@madduck.net>
Subject: [TopGit PATCH v2] tg-patch: use pretty_tree
Date: Tue,  5 Oct 2010 21:04:46 +0200	[thread overview]
Message-ID: <1286305486-28607-1-git-send-email-bert.wesarg@googlemail.com> (raw)
In-Reply-To: <AANLkTikXT=rzOJTTcNOsWkXctKOM3FzQ9ycVtOprLHGh@mail.gmail.com>

This applies the same treatment to tg-patch like tg-files got in v2.

Signed-off-by: Bert Wesarg <bert.wesarg@googlemail.com>

---

Basing the decision whether to use the ui diff or the porcelain diff-tree
is probably very unorthodox, but also makes sense, doesn't it?

Changes:
 v2:
  * apply suggestions from Uwe made to tg-files here too
  * the running pager decides whether we use the ui diff or the porcelain
    diff-tree

 tg-patch.sh |   67 +++++++++++++++++++++++++++++++++-------------------------
 1 files changed, 38 insertions(+), 29 deletions(-)

diff --git a/tg-patch.sh b/tg-patch.sh
index 7bafdfe..e88985a 100644 tg-patch.sh
--- a/tg-patch.sh
+++ b/tg-patch.sh
@@ -4,24 +4,18 @@
 # GPLv2
 
 name=
-
 topic=
-diff_opts=
-diff_committed_only=yes	# will be unset for index/worktree
-
+topic_for_pretty_tree=
 
 ## Parse options
 
 while [ -n "$1" ]; do
 	arg="$1"; shift
 	case "$arg" in
-	-i)
-		topic='(i)'
-		diff_opts="$diff_opts --cached";
-		diff_committed_only=;;
-	-w)
-		topic='(w)'
-		diff_committed_only=;;
+	-i|-w)
+		[ -z "$topic" ] || die "-i and -w are mutually exclusive"
+		topic="(${arg#-})"
+		topic_for_pretty_tree="$arg";;
 	-*)
 		echo "Usage: tg [...] patch [-i | -w] [NAME]" >&2
 		exit 1;;
@@ -32,8 +26,8 @@ while [ -n "$1" ]; do
 done
 
 
-[ -n "$name"  -a  -z "$diff_committed_only" ]  &&
-	die "-i/-w are mutually exclusive with NAME"
+[ -n "$name" -a -n "$topic" ] &&
+	die "$topic are mutually exclusive with NAME"
 
 [ -n "$name" ] || name="$(git symbolic-ref HEAD | sed 's#^refs/\(heads\|top-bases\)/##')"
 base_rev="$(git rev-parse --short --verify "refs/top-bases/$name" 2>/dev/null)" ||
@@ -46,22 +40,37 @@ base_rev="$(git rev-parse --short --verify "refs/top-bases/$name" 2>/dev/null)"
 
 setup_pager
 
-cat_file "$topic:.topmsg"
-echo
-[ -n "$(git grep $diff_opts '^[-]--' ${diff_committed_only:+"$name"} -- ".topmsg")" ] || echo '---'
-
-# Evil obnoxious hack to work around the lack of git diff --exclude
-git_is_stupid="$(mktemp -t tg-patch-changes.XXXXXX)"
-git diff --name-only $diff_opts "$base_rev" ${diff_committed_only:+"$name"} -- |
-	fgrep -vx ".topdeps" |
-	fgrep -vx ".topmsg" >"$git_is_stupid" || : # fgrep likes to fail randomly?
-if [ -s "$git_is_stupid" ]; then
-	cd "$root_dir"
-	cat "$git_is_stupid" | xargs git diff -a --patch-with-stat $diff_opts "$base_rev" ${diff_committed_only:+"$name"} --
-else
-	echo "No changes."
-fi
-rm "$git_is_stupid"
+# put out the commit message
+# and put an empty line out, if the last one in the message was not an empty line
+# and put out "---" if the commit message does not have one yet
+cat_file "$topic:.topmsg" |
+	awk '
+/^---/ {
+    has_3dash=1;
+}
+       {
+    need_empty = 1;
+    if ($0 == "")
+        need_empty = 0;
+    print;
+}
+END    {
+    if (need_empty)
+        print "";
+    if (!has_3dash)
+        print "---";
+}
+'
+
+b_tree=$(pretty_tree "$name" -b)
+t_tree=$(pretty_tree "$name" $topic_for_pretty_tree)
+
+# use the ui diff command when the pager is active
+diff_command=diff
+[ "x$GIT_PAGER_IN_USE" = "x1" ] ||
+	diff_command=diff-tree
+
+git $diff_command -p --stat $b_tree $t_tree
 
 echo '-- '
 echo "tg: ($base_rev..) $name (depends on: $(cat_file "$topic:.topdeps" | paste -s -d' '))"
-- 
tg: (aaf1181..) bw/tg-patch-pretty_tree (depends on: bw/files)

  reply	other threads:[~2010-10-05 19:04 UTC|newest]

Thread overview: 39+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2010-10-03 19:15 planning a new topgit release Uwe Kleine-König
2010-10-03 21:21 ` Bert Wesarg
2010-10-03 21:25   ` [TopGit PATCH 1/6] Let tg-update take a branch parameter Bert Wesarg
2010-10-03 21:25     ` [TopGit PATCH 2/6] tg-remote: use default remote if non is given Bert Wesarg
2010-10-03 21:25       ` [TopGit PATCH 3/6] tg-files: list files changed by the topic branch Bert Wesarg
2010-10-03 21:25         ` [TopGit PATCH 4/6] tg-prev/tg-next: commands to explore dependencies Bert Wesarg
2010-10-03 21:25           ` [TopGit PATCH 5/6] put die() messages to stderr Bert Wesarg
2010-10-03 21:25             ` [TopGit PATCH 6/6] tg-log: short cut to git log Bert Wesarg
     [not found]               ` <AANLkTi=Kwx5avY7xRdWLS931zK2fi7cj5Q8u3++bqRO+@mail.gmail.com>
2010-10-04  6:45                 ` Bert Wesarg
2010-10-04 19:06                   ` [TopGit PATCH] tg-log: move note from tg base to tg log Bert Wesarg
2010-10-04 21:05                     ` Štěpán Němec
2010-10-04 21:08                       ` Bert Wesarg
2010-10-04  6:45                 ` [TopGit PATCH 6/6] tg-log: short cut to git log Uwe Kleine-König
2010-10-03 21:55           ` [TopGit PATCH 4/6] tg-prev/tg-next: commands to explore dependencies Uwe Kleine-König
2010-10-04  6:48             ` Bert Wesarg
2010-10-03 22:03         ` [TopGit PATCH 3/6] tg-files: list files changed by the topic branch Uwe Kleine-König
2010-10-04  6:43           ` Bert Wesarg
2010-10-04  6:47             ` Uwe Kleine-König
2010-10-04  6:50               ` Bert Wesarg
2010-10-04  6:59                 ` Uwe Kleine-König
2010-10-04 13:16                   ` [TopGit PATCH] " Bert Wesarg
2010-10-04 13:52                     ` Uwe Kleine-König
2010-10-04 16:02                       ` Bert Wesarg
2010-10-04 18:27                         ` [TopGit PATCH v3] " Bert Wesarg
2010-10-04 20:09                           ` [TopGit PATCH] tg-patch: use pretty_tree Bert Wesarg
2010-10-04 23:02                             ` Bert Wesarg
2010-10-05  7:18                               ` Uwe Kleine-König
2010-10-05  8:05                                 ` Bert Wesarg
2010-10-05 19:04                                   ` Bert Wesarg [this message]
2010-10-05 20:01                                     ` [TopGit PATCH v2] " Uwe Kleine-König
2010-10-05 20:14                                       ` Bert Wesarg
2010-10-05  7:17                           ` [TopGit PATCH v3] tg-files: list files changed by the topic branch Uwe Kleine-König
2010-10-05 19:03                             ` [TopGit PATCH v4] " Bert Wesarg
2010-10-05 22:02                               ` Štěpán Němec
2010-10-06  6:11                                 ` Bert Wesarg
2010-10-03 22:00       ` [TopGit PATCH 2/6] tg-remote: use default remote if non is given Uwe Kleine-König
2010-10-04  3:13       ` Ævar Arnfjörð Bjarmason
2010-10-04  6:43         ` Uwe Kleine-König
2010-10-03 22:11   ` planning a new topgit release Uwe Kleine-König

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1286305486-28607-1-git-send-email-bert.wesarg@googlemail.com \
    --to=bert.wesarg@googlemail.com \
    --cc=ceder@lysator.liu.se \
    --cc=git@vger.kernel.org \
    --cc=madduck@madduck.net \
    --cc=odabrunz@gmx.net \
    --cc=pasky@suse.cz \
    --cc=simons@cryp.to \
    --cc=thomas.moschny@gmx.de \
    --cc=u.kleine-koenig@pengutronix.de \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).